#!BPY
"""
Name: 'Cogwheel'
Blender: 241
Group: 'Mesh'
Tip: 'It changes the size of the surface.'
"""

__author__ = 'Nabubun'
__version__ = '1.0 2006/07/20'
__url__ = ["", "", "", ""]
__email__ = ["Nabubun", ""]
__bpydoc__ = """\
It changes the size of the surface.

Shortcuts:<br>
	None.

Supported:<br>
	Window.

Known issues:<br>

Notes:<br>

"""

import Blender
from Blender import *


def seeksCenterSurface(sfa):
	x = y = z = 0.
	le = len(sfa.v)
	for i in sfa.v:
		x += i.co.x
		y += i.co.y
		z += i.co.z
	x /= le
	y /= le
	z /= le
	return([x, y, z])

def transformingVertex(sfa):
	global Bu_x, Bu_y, Bu_z
	c = seeksCenterSurface(sfa)
	for i in sfa.v:
		if Bu_x.val:
			print "X", Bu_x.val
			i.co.x = c[0] - (c[0] - i.co.x) * Bu_p.val / 100
		if Bu_y.val:
			print "Y", Bu_y.val
			i.co.y = c[1] - (c[1] - i.co.y) * Bu_p.val / 100
		if Bu_z.val:
			print "Z", Bu_z.val
			i.co.z = c[2] - (c[2] - i.co.z) * Bu_p.val / 100
	return(True)

def transformingSurface(s_fa):
	#global me
	for i in s_fa:
		transformingVertex(i)
	return

def checkSurface(s_fa):
	global me
	#print "checkSurface"
	v =[]
	for i in s_fa:
		for j in i.v:
			if v.count(j) == 0:
				v.append(j)
			else:
				Draw.PupMenu("he leading surface can not be processed.")
				return
	return(True)

def getSelectedSurface():
	global me
	s_fa = []
	for i in me.faces:
		if i.sel:
			s_fa.append(i)
	if s_fa == []:
		Draw.PupMenu("Choose equal to or more than one Surface.")
	return(s_fa)

def cogwheel():
	global me
	s_fa = getSelectedSurface()
	if s_fa  == []:
		return
	if not checkSurface(s_fa):
		return
	transformingSurface(s_fa)
	me.update()
	return(True)	

def getNMeshName():
	scene = Scene.GetCurrent()
	if not scene:
		Draw.PupMenu("Error: There is not a scene.")
		return
	ob = scene.getActiveObject()
	#print ob
	if ob.getType() != 'Mesh':
		Draw.PupMenu("Error: Activate meshes.")
		return
	me_name = ob.getData(True)
	#print me_name
	return(me_name)

# ----- button -----
Button = []
Bu_p = Draw.Create(50)
Button.append(("percent:", Bu_p, 0, 200))
Bu_x = Draw.Create(1)
Button.append(("X", Bu_x))
Bu_y = Draw.Create(1)
Button.append(("Y", Bu_y))
Bu_z = Draw.Create(1)
Button.append(("Z", Bu_z))

# ----- main -----
me_name = getNMeshName()
if me_name:
	Bu_r = Draw.PupBlock("Cogwheel...", Button)
	if (Bu_r):
		mode = Window.EditMode()
		if mode:
			Window.EditMode(0)
			print "Start Cogwheel."
			print "Object neme is", me_name, "."
			me = NMesh.GetRaw(me_name)
			cogwheel()
			print "End Cogwheel."
			Window.EditMode(1)
			Redraw()
		else:
			Draw.PupMenu("Have an edit mode.")
else:
	print "Error"